//import java.util.*;
import gnu.trove.*;

class aerospace
{
    public static void main(String[] args)
    {
        // constants
        
        // planning horizon H
        int H=30;  // [0,30]
        
        // number of FSA cycles and states
        int cycles=5;
        int n=4;
        // required thrust Bmin
        int totalthrust=100;
        
        qcsp prob = new qcsp();
        // environment variables here.
        
        //mid_domain [][] thrustcycles=new mid_domain[cycles][];
        //mid_domain [][] tempcycles=new mid_domain[cycles][];
        
        mid_domain [] temperature= new mid_domain[H+1];
        mid_domain [] thrust= new mid_domain[H+1];
        
        mid_domain [] thrustByState=new mid_domain[n];
        mid_domain [] tempByState=new mid_domain[n];
        
        for(int state=0; state<n; state++)
        {
            
        }
        
        for(int cycle=0; cycle<cycles; cycle++)
        {
            // generate all the vars in cycle order.
            
            mid_domain [] thrustperstate= new mid_domain[4];   // 4 states
            mid_domain [] tempgradient= new mid_domain[4];
            
            thrustcycles[cycle]=thrustperstate;
            tempcycles[cycle]=thrustperstate;
            
            for(int i=0; i<4; i++)
            {
                thrustperstate[i]=new universal(2, prob, "c"+i+"_0");
                prob.addvar(thrustperstate[i]);
                
                tempgradient[i]=new universal(2, prob, "c"+i+"_1");
                prob.addvar(tempgradient[i]);
            }
        }
        
        // physical parameters -- cumulative thrust
        for(int i=0; i<H; i++)
        {
            // temp h
            temp[i]=new existential(30, prob, "h"+i);
            prob.addvar(temp[i]);
            
            // cumulative thrust b
            thrust[i]=new existential(30, prob, "b"+i);
            prob.addvar(thrust[i]);
        }
        
        variable [] c0array = new variable[cycles];
        variable [] c1array = new variable[cycles];
        
        variable [] t0array = new variable[cycles];
        variable [] t1array = new variable[cycles];
        variable [] t2array = new variable[cycles];
        variable [] t3array = new variable[cycles];
        
        for(int i=0; i<cycles; i++)
        {
            
            // variables[curvar]=new existential(2, prob, "c"+i+"_0");  // what was this for?
            
            // binary decision variables c^i_0 and c^i_1
            c0array[i]=new existential(2, prob, "c"+i+"_0");
            prob.addvar(c0array[i]);
            
            c1array[i]=new existential(2, prob, "c"+i+"_1");
            prob.addvar(c1array[i]);
            
            // time out variables T^i_0,1,2,3
            t0array[i]=new existential(2, prob, "t"+i+"_0");
            prob.addvar(t0array[i]);
            
            t1array[i]=new existential(2, prob, "t"+i+"_1");
            prob.addvar(t1array[i]);
            
            t2array[i]=new existential(2, prob, "t"+i+"_2");
            prob.addvar(t2array[i]);
            
            t3array[i]=new existential(2, prob, "t"+i+"_3");
            prob.addvar(t3array[i]);
        }
        
        // state variables i.e. what state are we in at time step x
        
        variable[] states= new variable[H];
        
        for(int i=0; i<H; i++)
        {
            states[i]=new existential(4, prob, "state_"+i);
            prob.addvar(states[i]);
        }
        
        // c0 xor c1
        
        {THashMap goods= new THashMap();  // <pa, goodlistwrapper>
        int [][] goodlist={{0,1},{1,0}};
        
        for(int i=0; i<cycles; i++)
        {
            variable[] gsvars= {c0array[i], c1array[i]};
            
            gac_schema_positive cons= new gac_schema_positive(gsvars, prob, goods);
            if(i==0) cons.splittuples(goods, goodlist);
        }}
        
        // relate the state to the evolution of the physical parameters.
        
        /*
        
        for(int i=0; i<H; i++)
        {
            variable[] gsvars= {c0array[i], c1array[i]};
            
            gac_schema_positive cons= new gac_schema_positive(gsvars, prob, goods);
            if(i==0) cons.splittuples(goods, goodlist);
            
            
        }
        */
        
        
        /*
        
        variable[] gsvars= {variables[0], variables[1], variables[2], variables[3]};
        
        gac_schema_positive c1= new gac_schema_positive(gsvars, prob, goods);
                
        constraints[0]=c1;
        
        System.out.println(c1.establish_gac());
        
        prob.printdomains();
        
        c1.add_backtrack_level();
        
        System.out.println(c1);
        
        System.out.println(variables[3].exclude(3, null));
        
        System.out.println(prob.make_ac());
        
        prob.printdomains();
        
        prob.backtrack.backtrack();
        
        prob.printdomains();
        
        System.out.println(c1);
        
        System.out.println("Now testing gac_schema_predicate --------------------");
        
        variables = new variable[4];
        constraints = new constraint[1];
        
        prob = new qcsp(variables, constraints);
        
        variables[0]=new existential(4, prob, 0, "a");
        variables[1]=new universal(2, prob, 1, "b");
        variables[2]=new existential(3, prob, 2, "c");
        variables[3]=new existential(4, prob, 3, "d");
        
        alldiff_predicate temp= new alldiff_predicate();
        variable [] gsvars2= {variables[0], variables[1], variables[2], variables[3]};
        
        gac_schema_predicate c2= new gac_schema_predicate(gsvars2, prob, temp);
        
        System.out.println(c2.establish_gac());
        
        prob.printdomains();
        
        c2.add_backtrack_level();
        
        System.out.println(c2);
        
        System.out.println(variables[3].exclude(3, null));
        
        prob.printdomains();
        
        System.out.println(prob.make_ac());
        
        prob.printdomains();
        
        c2.backtrack();
        
        prob.printdomains();
        
        System.out.println(c2);*/
    }
}


